/**
 ** @author: Ben Y. Zhao (ravenben@cs.berkeley.edu)
 ** @version: CVS Version: $Revision: 1.4 $  Date: $Date: 2000/01/06 21:19:18 $
 ** (c) 2000 by Ben Yanbin Zhao and the Regents of the University of California
 **/

package ninja.xset;

import java.util.*;
//import ninja.*;
import java.io.*;
import org.w3c.dom.*;

public class TestSET {

  protected Vector hPtr;
  protected SETserver server;

  /*  public TestSET (long refreshrate) {
      server = new SETserver(refreshrate);
      }*/
  public TestSET (String storPath) {
    server = new SETserver(storPath);
  }
  
  protected boolean register(Document d) {
    return true;
  }
  
  protected boolean query(Document q) {
    return true;
  }
  
  public void test(String queryFile, String storPath) {
    Document d = null;;
    File path = null;
    String [] xmlFiles = null;

    try {
	path = new File(storPath);
	if ((xmlFiles = path.list(new ExtensionFilter("xml"))) == null) {
	    System.out.println("Directory not found or inaccessible!");
	    System.exit(-1);
	}

      DOMParser parser = new DOMParser();
      for (int i = 0; i < xmlFiles.length; i++) {
	System.out.println("*******************\n"+xmlFiles[i]+
			   " file loaded.");
	parser.parse(path+"/"+xmlFiles[i]);
	d = parser.getDocument();
	server.SETregister(d, (long)i);
	parser.reset();
	//	server.printSET("SET");
      }

      hPtr = server.querySET(d);
      System.out.println(hPtr);
      server.SETderegister(d);
      hPtr = server.querySET(d);
      System.out.println(hPtr);
    } catch (FileNotFoundException fnfe) {
      System.out.println("Query file not found!!");
      System.exit(-1);
    } catch (Exception pp) {
      pp.printStackTrace();
    }
    Enumeration e = null;
    if (hPtr != null) {
      e = hPtr.elements();
      ServiceEntry se = null;
      while (e.hasMoreElements()) {
	se = (ServiceEntry) e.nextElement();
	System.out.println("Service ID: "+se.getid());
	System.out.println("Found match!\n"+se.toString());
      }
    } else {
      System.out.println("NO MATCH!");
    }

    return;
  }
  
  public static void main(String argv[]) {
    if (argv.length != 2) {
      System.err.println("Need two arguments, queryFile and path");
      System.exit(1);
    } else {
      TestSET ts = new TestSET(argv[1]);
      ts.test(argv[0], argv[1]);
    }
    System.exit(0);
  }
}
